/**
 * @file
 * Converts pre.pgn4web into iframe.pgn4web using the pgn4web board.html.
 */
(function ($) {
  Drupal.behaviors.pgn4web = {
    attach: function(context) {
      // TODO: only do this if we have a correct library path!
      $('pre.pgn4web').each(function(index) {
        // Give this an id and hide it.
        var this_id = "pgn4web_" + index;
        $(this).attr("id", this_id).hide();

        // Construct pgn4web url.
        // TODO: allow users to set these settings board-specific.
        var pgn4web_url = Drupal.settings.pgn4web.path;
        pgn4web_url += '/board.html?';
        pgn4web_url += 'pi=' + this_id;
        pgn4web_url += '&' + Drupal.settings.pgn4web.query;

        // Check if we have more than one game.
        // See : http://code.google.com/p/pgn4web/wiki/User_Notes_drupal
        // about this regular expression.
        var game_text = $(this).html();
        var iframe_classes = 'pgn4web';
        var multiGamesRegexp = /\s*\[\s*\w+\s*"[^"]*"\s*\]\s*[^\s\[\]]+[\s\S]*\[\s*\w+\s*"[^"]*"\s*\]\s*/m;
        iframe_classes += ' pgn4web-' + (multiGamesRegexp.test(game_text) ? 'multiple' : 'single');

        // Add an iframe.
        $(this).after("<iframe class='" + iframe_classes + "' src='" + pgn4web_url + "'>" + game_text + "</iframe>");
      });
    }

    // TODO: I don't understand whether we need a "detach" here... should we
    // remove all iframe.pgn4web from the content or not ?
  };

})(jQuery);
